<!DOCTYPE html>
<html lang="en">

<head>
    <title>Admin Project Course365</title>
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css">
    <!-- Data Table-->
    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
</head>

<body>
    <!-- Vùng header-->
    <div class="container">
        <div class="text-center mt-3">
            <h2>Quản trị Khóa học</h2>
        </div>
        <div class="form-group">
            <button class="btn btn-success" id="btn-add-course"><i class="fa fa-plus"></i>&nbsp; New Course</button>
        </div>
    </div>
    <!--Course Data Table-->
    <div class="container">
        <table class="table table-bordered table-striped table-hover" id="course-table">
            <thead>
                <tr>
                    <th>ID</th>
                    <th>Mã khóa học</th>
                    <th>Tên khóa học</th>
                    <th>Giá niêm yết</th>
                    <th>Giá bán thực tế</th>
                    <th>Độ dài khóa học</th>
                    <th>Trình độ khóa học</th>
                    <th>Tên giáo viên</th>
                    <th>Action</th>
                </tr>
            </thead>
        </table>
    </div>
    <!--Vùng Modal-->
    <!--Create Course modal-->
    <div>
        <div id="create-course-modal" class="modal fade" tabindex="-1">
            <div class="modal-dialog">
                <div class="modal-content">
                    <div class="modal-header">
                        <h5 class="modal-title" id="h5-modal-title">Create new course</h5>
                        <button class="close" data-dismiss="modal">&times;</button>
                    </div>
                    <div class="modal-body">
                        <form>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label for="input-create-course-code">Mã khóa học</label>
                                </div>
                                <div class="col-sm-8">
                                    <input type="text" id="input-create-course-code" name="courseCode"
                                        placeholder="Mã khóa học" class="form-control">
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label for="input-create-course-name">Tên khóa học</label>
                                </div>
                                <div class="col-sm-8">
                                    <input type="text" id="input-create-course-name" name="courseName"
                                        placeholder="Tên khóa học" class="form-control">
                                </div>
                            </div>
                            <div class="row form-group">
                                <label for="select-create-course-level" class="col-form-label col-sm-4">Trình độ khóa
                                    học</label>
                                <div class="col-sm-8">
                                    <select id="select-create-course-level" class="form-control">
                                        <option value="Beginner">Beginner</option>
                                        <option value="Intermediate">Intermediate</option>
                                        <option value="Advanced">Advanced</option>
                                    </select>
                                </div>
                            </div>
                            <div class="row form-group">
                                <label class="col-form-label col-sm-4" for="input-create-price">Giá niêm yết</label>
                                <div class="col-sm-8">
                                    <input type="number" id="input-create-price" name="price" placeholder="Giá niêm yết"
                                        class="form-control">
                                </div>
                            </div>
                            <div class="row form-group">
                                <label class="col-form-label col-sm-4" for="input-create-discount-price">Giá thực
                                    tế</label>
                                <div class="col-sm-8">
                                    <input type="number" id="input-create-discount-price" name="discountPrice"
                                        placeholder="Giá bán thực tế" class="form-control">
                                </div>
                            </div>
                            <div class="row form-group">
                                <label class="col-form-label col-sm-4" for="input-create-duration">Độ dài khóa
                                    học</label>
                                <div class="col-sm-8">
                                    <input type="number" id="input-create-duration" name="duration"
                                        placeholder="Độ dài khóa học" class="form-control">
                                </div>
                            </div>
                            <div class="row form-group">
                                <label class="col-form-label col-sm-4" for="input-create-teacher-name">Tên giáo
                                    viên</label>
                                <div class="col-sm-8">
                                    <input type="number" id="input-create-teacher-name" name="teacherName"
                                        placeholder="Tên giáo viên" class="form-control">
                                </div>
                            </div>
                        </form>
                    </div>
                    <div class="modal-footer">
                        <button class="btn btn-primary" id="btn-create-course">Insert Course</button>
                        <button class="btn btn-secondary" id="btn-create-cancel" data-dismiss="modal">Cancel</button>
                    </div>
                </div>
            </div>
        </div>
    </div>
    <!--Edit Course Modal-->
    <div>
        <div id="update-course-modal" class="modal fade" tabindex="-1">
            <div class="modal-dialog">
                <div class="modal-content">
                    <div class="modal-header">
                        <h5 class="modal-title" id="h5-modal-title">Edit course</h5>
                        <button class="close" data-dismiss="modal">&times;</button>
                    </div>
                    <div class="modal-body">
                        <form>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label for="input-update-course-code">Mã khóa học</label>
                                </div>
                                <div class="col-sm-8">
                                    <input type="text" id="input-update-course-code" name="courseCode"
                                        placeholder="Mã khóa học" class="form-control">
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label for="input-update-course-name">Tên khóa học</label>
                                </div>
                                <div class="col-sm-8">
                                    <input type="text" id="input-update-course-name" name="courseName"
                                        placeholder="Tên khóa học" class="form-control">
                                </div>
                            </div>
                            <div class="row form-group">
                                <label for="select-update-course-level" class="col-form-label col-sm-4">Trình độ khóa
                                    học</label>
                                <div class="col-sm-8">
                                    <select id="select-update-course-level" class="form-control">
                                        <option value="Beginner">Beginner</option>
                                        <option value="Intermediate">Intermediate</option>
                                        <option value="Advanced">Advanced</option>
                                    </select>
                                </div>
                            </div>
                            <div class="row form-group">
                                <label class="col-form-label col-sm-4" for="input-update-price">Giá niêm yết</label>
                                <div class="col-sm-8">
                                    <input type="number" id="input-update-price" name="price" placeholder="Giá niêm yết"
                                        class="form-control">
                                </div>
                            </div>
                            <div class="row form-group">
                                <label class="col-form-label col-sm-4" for="input-update-discount-price">Giá thực
                                    tế</label>
                                <div class="col-sm-8">
                                    <input type="number" id="input-update-discount-price" name="discountPrice"
                                        placeholder="Giá bán thực tế" class="form-control">
                                </div>
                            </div>
                            <div class="row form-group">
                                <label class="col-form-label col-sm-4" for="input-update-duration">Độ dài khóa
                                    học</label>
                                <div class="col-sm-8">
                                    <input type="number" id="input-update-duration" name="duration"
                                        placeholder="Độ dài khóa học" class="form-control">
                                </div>
                            </div>
                            <div class="row form-group">
                                <label class="col-form-label col-sm-4" for="input-update-teacher-name">Tên giáo
                                    viên</label>
                                <div class="col-sm-8">
                                    <input type="number" id="input-update-teacher-name" name="teacherName"
                                        placeholder="Tên giáo viên" class="form-control">
                                </div>
                            </div>
                        </form>
                    </div>
                    <div class="modal-footer">
                        <button class="btn btn-primary" id="btn-update-course">Update Course</button>
                        <button class="btn btn-secondary" id="btn-create-cancel" data-dismiss="modal">Cancel</button>
                    </div>
                </div>
            </div>
        </div>
    </div>
    <!-- Delete confirm modal -->
    <div>
        <div class="modal fade" tabindex="-1" id="delete-confirm-modal">
            <div class="modal-dialog">
                <div class="modal-content">
                    <div class="modal-header">
                        <h5 class="modal-title" id="h5-modal-title">Course Delete Confirmation</h5>
                        <button class="close" data-dismiss="modal">&times;</button>
                    </div>
                    <div class="modal-body">
                        <label>Bạn có chắc chắn muốn xóa course này không?</label>
                    </div>
                    <div class="modal-footer">
                        <button class="btn btn-danger" id="btn-confirm-delete-course">Confirm</button>
                        <button class="btn btn-secondary" data-dismiss="modal">Cancel</button>
                    </div>
                </div>
            </div>
        </div>
    </div>
</body>
<script>
    "use strict";
    /*** REGION 1 - Global Variables */
    const gBASE_URL = "https://630890e4722029d9ddd245bc.mockapi.io/api/v1";
    //Biến toàn cục để lưu trữ id course đang được update or delete. Mặc định = 0;
    var gCourseId = 0;

    // Biến mảng hằng số chứa danh sách tên các thuộc tính
    const gCOURSE_COLS = ["id", "courseCode", "courseName", "price", "discountPrice", "duration", "level", "teacherName", "action"]

    //Biến mảng toàn cục định nghĩa chỉ số các cột tương ứng
    const gCOURSE_ID_COL = 0;
    const gCOURSE_CODE_COL = 1;
    const gCOURSE_NAME_COL = 2;
    const gCOURSE_PRICE_COL = 3;
    const gCOURSE_DISCOUNT_PRICE_COL = 4;
    const gCOURSE_DURATION_COL = 5;
    const gCOURSE_LEVEL_COL = 6;
    const gCOURSE_TEACHER_NAME_COL = 7;
    const gCOURSE_ACTION_COL = 8;

    // Khai báo DataTable & Mapping column
    var gCourseTable = $("#course-table").DataTable({
        columns: [
            { data: gCOURSE_COLS[gCOURSE_ID_COL] },
            { data: gCOURSE_COLS[gCOURSE_CODE_COL] },
            { data: gCOURSE_COLS[gCOURSE_NAME_COL] },
            { data: gCOURSE_COLS[gCOURSE_PRICE_COL] },
            { data: gCOURSE_COLS[gCOURSE_DISCOUNT_PRICE_COL] },
            { data: gCOURSE_COLS[gCOURSE_DURATION_COL] },
            { data: gCOURSE_COLS[gCOURSE_LEVEL_COL] },
            { data: gCOURSE_COLS[gCOURSE_TEACHER_NAME_COL] },
            { data: gCOURSE_COLS[gCOURSE_ACTION_COL] }
        ],
        columnDefs: [
            { // định nghĩa các cột action
                targets: gCOURSE_ACTION_COL,
                defaultContent: `
                    <img class="edit-user" src="https://cdn0.iconfinder.com/data/icons/glyphpack/45/edit-alt-512.png" style="width: 20px;cursor:pointer;">
                    <img class="delete-user" src="https://cdn4.iconfinder.com/data/icons/complete-common-version-6-4/1024/trash-512.png" style="width: 20px;cursor:pointer;">
                `
            }
        ]
    });
    /*** REGION 2 - Vùng gán/  thực thi sự kiện cho các element */
    $(document).ready(function () {
        onPageLoading();
    });

    // gán sự kiện Create - them 1 course
    $("#btn-add-course").on("click", function () {
        onBtnAddNewCourseClick();
    });
    // gán sự kiện Insert Course - them 1 course tren modal
    $("#btn-create-course").on("click", function () {
        onBtnCreateCourseClick();
    });

    // gán sự kiện Update - sửa 1 course
    $("#course-table").on("click", ".edit-user", function () {
        onBtnEditCourseClick(this);
    });

    // gán sự kiện cho nút Update course (trên modal)
    $("#btn-update-course").on("click", function () {
        onBtnUpdateCourseClick();
    });

    // gán sự kiện Delete - xoa 1 course
    $("#course-table").on("click", ".delete-course", function () {
        onBtnDeleteCourseClick(this);
    });

    // gán sự kiện cho nút Confirm Delete User (trên modal)
    $("#btn-confirm-delete-course").on("click", function () {
        onBtnConfirmDeleteCourseClick();
    });

    /*** REGION 3 - Event handlers */
    function onPageLoading() {
        getAllCourses();
    }

    // Hàm xử lý sự kiện khi New Course được click
    function onBtnAddNewCourseClick() {
        //hiển thị modal trắng lên
        $("#create-course-modal").modal("show");
    }
    // Hàm xử lý sự kiện khi Insert Course được click
    function onBtnCreateCourseClick() {
        //khai báo đối tượng chứa course data
        var vObjectRequestData = {
            courseCode: "",
            courseName: "",
            level: "",
            price: "",
            discountPrice: "",
            duration: "",
            teacherName: "",
        };
        //B1: thu thap du lieu
        getInsertCourseData(vObjectRequestData);
        //B2: Validate Insert
        var vIsValidate = validateCourseData(vObjectRequestData);
        //ghi ra console giá trị trả ra của hàm validateUserData
        console.log(vIsValidate);
        //B3: Insert Course
        $.ajax({
            url: gBASE_URL,
            type: "POST",
            contentType: "application/json;charset=UTF-8",
            data: JSON.stringify(vObjectRequestData),
            success: function (paramRes) {
                //Ghi response ra console
                console.log(paramRes);
                //B4: front-end 
                handleInsertCourseSuccess();
            },
            error: function (paramErr) {
                console.log(paramErr.status)
            }
        });
    }

    // Hàm xử lý sự kiện khi icon edit course trên bảng được click
    function onBtnEditCourseClick(paramBtnEdit) {
        //lưu thông tin courseId đang được edit vào biến toàn cục
        gCourseId = getCourseIdFromButton(paramBtnEdit);
        console.log("Id = " + gCourseId);
        //hiển thị modal trắng lên
        $("#update-course-modal").modal("show");
        // load dữ liệu vào các trường dữ liệu trong modal
        getCourseById(gCourseId);
    }
    // hàm xử lý sự kiện update course modal click
    function onBtnUpdateCourseClick() {
        // khai báo đối tượng chứa course data
        var vCourseObj = {
            courseCode: "",
            courseName: "",
            level: "",
            price: "",
            discountPrice: "",
            duration: "",
            teacherName: "",
        };
        // B1: Thu thập dữ liệu
        getUpdateCourseData(vCourseObj);
        // B2: Validate update
        var vIsCourseValidate = validateCourseData(vCourseObj);
        if (vIsCourseValidate) {
            // B3: update user
            $.ajax({
                url: gBASE_URL + "/courses" + gCourseId,
                type: "PUT",
                contentType: "application/json;charset=UTF-8",
                data: JSON.stringify(vCourseObj),
                success: function (paramRes) {
                    // B4: xử lý front-end
                    handleUpdateCourseSuccess();
                },
                error: function (paramErr) {
                    console.log(paramErr.status);
                }
            });
        }
    }
    // Hàm xử lý sự kiện khi icon delete course trên bảng được click
    function onBtnDeleteCourseClick(paramBtnDelete) {
        //lưu thông tin userId đang được xoa vào biến toàn cục
        gCourseId = getCourseIdFromButton(paramBtnDelete);
        console.log("Id = " + gCourseId);
        // hiển thị modal confirm delete lên
        $("#delete-confirm-modal").modal("show");
    }
    // Hàm xử lý sự kiện khi nút confirm delete course trên modal được click
    function onBtnConfirmDeleteCourseClick() {
        $.ajax({
            url: gBASE_URL + "/course/" + gCourseId,
            type: "DELETE",
            success: function (paramRes) {
                // B4: xử lý front-end
                handleDeleteCourseSuccess();
            },
            error: function (paramErr) {
                console.log(paramErr.status);
            }
        });
    }
    /*** REGION 4 - Common Functions */
    /** load users to Datatable
    * in: users array
    * out: user table has data
    */
    function loadDataToCourseTable(paramCourses) {
        gCourseTable.clear();
        gCourseTable.rows.add(paramCourses);
        gCourseTable.draw();
    }
    //hàm gọi api để lấy danh sách all user đăng ký
    function getAllCourses() {
        $.ajax({
            url: gBASE_URL + "/courses",
            type: "GET",
            success: function (paramCourses) {
                // Ghi Response ra console
                console.log(paramCourses);
                loadDataToCourseTable(paramCourses);
            },
            error: function (paramErr) {
                console.log(paramErr.status);
            }
        });
    }

    // hàm get course by id
    function getCourseById(paramCourseId) {
        $.ajax({
            url: gBASE_URL + paramCourseId,
            type: "GET",
            success: function (paramCourse) {
                showCourseDataToModal(paramCourse);
            },
            error: function (paramErr) {
                console.log(paramErr.status);
            }
        });
    }
    // hàm show course obj lên modal
    function showCourseDataToModal(paramCourse) {
        $("#input-update-course-code").val(paramCourse.courseCode);
        $("#input-update-course-name").val(paramCourse.courseName);
        $("#select-update-course-level").val(paramCourse.level);
        $("#input-update-price").val(paramCourse.price);
        $("#input-update-discount-price").val(paramCourse.discountPrice);
        $("#input-update-duration").val(paramCourse.duration);
        $("#input-update-teacher-name").val(paramCourse.teacherName);
    }

    // hàm dựa vào button detail (edit or delete) xác định được id course
    function getCourseIdFromButton(paramButton) {
        var vTableRow = $(paramButton).parents("tr");
        var vCourseRowData = gCourseTable.row(vTableRow).data();
        return vCourseRowData.id;
    }

    //hàm thu thâpj dữ liệu để create Course
    function getInsertCourseData(paramCourseObj) {
        paramCourseObj.courseCode = $("#input-create-course-code").val().trim();
        paramCourseObj.courseName = $("#input-create-course-name").val().trim();
        paramCourseObj.level = $("#select-create-course-level").val();
        paramCourseObj.price = $("#input-create-price").val().trim();
        paramCourseObj.discountPrice = $("#input-create-discount-price").val().trim();
        paramCourseObj.duration = $("#input-create-duration").val().trim();
        paramCourseObj.teacherName = $("#input-create-teacher-name").val().trim();
    }

    // hàm validate data
    function validateCourseData(paramCourseObj) {
        if (paramCourseObj.courseCode === "") {
            alert("Enter course Code!");
            return false;
        }

        if (paramCourseObj.courseName === "") {
            alert("Enter course Name!");
            return false;
        }

        if (paramCourseObj.level === "") {
            alert("Enter level!");
            return false;
        }

        if (paramCourseObj.price === "") {
            alert("Enter price!");
            return false;
        }

        if (paramCourseObj.discountPrice === "") {
            alert("Enter discount price!");
            return false;
        }

        if (paramCourseObj.duration === "") {
            alert("Enter duration!");
            return false;
        }

        if (paramCourseObj.teacherName === "") {
            alert("Enter teacher's name!");
            return false;
        }
        return true;
    }

    // xử lý front-end khi thêm course thành công
    //Khi người dùng ấn OK trên cửa sổ thông báo Alert: xóa trắng dữ liệu trên modal, tắt Modal đi và load lại bảng danh sách users
    function handleInsertCourseSuccess() {
        alert("Add course successful!");
        getAllCourses();
        resertCreateCourseForm();
        $("#create-course-modal").modal("hide");
    }

    //hàm xóa trắng form create course
    function resertCreateCourseForm() {
        $("#input-create-course-code").val("");
        $("#input-create-course-name").val("");
        $("#select-create-course-level").val("Beginner");
        $("#input-create-price").val("");
        $("#input-create-discount-price").val("");
        $("#input-create-duration").val("");
        $("#input-create-teacher-name").val("");
    }

    // hàm thu thập dữ liệu để update course
    function getUpdateCourseData(paramCourseObj) {
        paramCourseObj.courseCode = $("#input-update-course-code").val().trim();
        paramCourseObj.courseName = $("#input-update-course-name").val().trim();
        paramCourseObj.level = $("#select-update-course-level").val();
        paramCourseObj.price = $("#input-update-price").val().trim();
        paramCourseObj.discountPrice = $("#input-update-discount-price").val().trim();
        paramCourseObj.duration = $("#input-update-duration").val().trim();
        paramCourseObj.teacherName = $("#input-update-teacher-name").val().trim();
    }

    // hàm xử lý hiển thị front-end khi sửa course thành công
    function handleUpdateCourseSuccess() {
        alert("Sửa course thành công!");
        getAllCourses();
        resertUpdateCourseForm();
        $("#update-course-modal").modal("hide");
    }

    // hàm xóa trắng form update user
    function resertUpdateCourseForm() {
        $("#input-update-course-code").val("");
        $("#input-update-course-name").val("");
        $("#select-update-course-level").val("Beginner");
        $("#input-update-price").val("");
        $("#input-update-discount-price").val("");
        $("#input-update-duration").val("");
        $("#input-update-teacher-name").val("");
    }

    // hàm xử lý hiển thị front-end khi sửa course thành công
    function handleDeleteCourseSuccess() {
        alert("Delete course thành công!");
        getAllCourses();
        $("#delete-course-modal").modal("hide");
    }
</script>

</html>